package mapper;

import domain.PageQuery;
import domain.User;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

public interface UserMapper {
    List<User> findAll();
    void add(User user);
    void add2(User user);
    void update(User user);
    void delete(int userid);
    User findById(int userid);
    List<User> findByNameLike(String username);

    /**
     * 分页查询
     * @param startPage 开始索引
     * @param pageSize  每页条数
     * @return
     */
    List<User> findPage1(@Param("starPage") int startPage, @Param("pageSize") int pageSize);
    List<User> findPage2(PageQuery pageQuery);
    List<User> findPage3(Map<String,Object> params);

    /**
     * 聚合查询
     * @return
     */
    int findCount();
}
