package mapper;

import domain.User;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

public interface UserMapper2 {
    List<User> findByCondition(User user);
    void updateByCondition(User user);

    /**
     * 长度<5模糊查询 >10 精确查询 否则查询id=1
     * @param user
     * @return
     */
    List<User> findByUserName(String username);

    /**
     * 批量删除 delete from user where id in []
     * @param ids
     */
    void deleteBatch(int[] ids);

    /**
     * 批量新增 insert into user(username,sex,address) values(),(),()
     * @param users
     */
    void insertBatch(List<User> users);

    /**
     * 多条件查询  key:属性名 value:属性值
     * select * from user where username=? and sex=?
     * @param map
     * @return
     */
    List<User> findUser(@Param("queryMap")Map<String,Object> map);
}
