import domain.Teacher;
import mapper.TeacherMapper;
import mapper.UserMapper;
import org.apache.ibatis.io.Resources;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.SqlSessionFactory;
import org.apache.ibatis.session.SqlSessionFactoryBuilder;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import java.io.IOException;
import java.io.InputStream;
import java.util.List;

public class testTeacherMapper {
    InputStream is=null;
    SqlSession session=null;
    TeacherMapper mapper=null;
    @Before
    public void before() throws IOException {
        is= Resources.getResourceAsStream("SqlMapConfig.xml");
        SqlSessionFactoryBuilder sqlSessionFactoryBuilder = new SqlSessionFactoryBuilder();
        SqlSessionFactory build = sqlSessionFactoryBuilder.build(is);
        session=build.openSession();
        //代理对象操作数据库
        mapper = session.getMapper(TeacherMapper.class);
    }

    @Test
    public void testFindAll(){
        List<Teacher> all = mapper.findAll();
        all.forEach(System.out::println);
    }

    @Test
    public void testFindById(){
        Teacher teacher = mapper.findById(1);
        System.out.println(teacher);
    }

    @Test
    public void testFindById2(){
        List<Teacher> teachers = mapper.findById2(1);
        teachers.forEach(System.out::println);
    }

    @After
    public void after() throws IOException {
        session.close();
        is.close();
    }
}
