import domain.User;
import mapper.UserMapper;
import org.apache.ibatis.io.Resources;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.SqlSessionFactory;
import org.apache.ibatis.session.SqlSessionFactoryBuilder;
import org.junit.Test;

import java.io.IOException;
import java.io.InputStream;
import java.util.List;

public class testUserMapper{
    @Test
    //sqlSession对象获取代理对象
    public void testFindAll() throws IOException {
        InputStream is=Resources.getResourceAsStream("SqlMapConfig.xml");
        SqlSessionFactoryBuilder sqlSessionFactoryBuilder = new SqlSessionFactoryBuilder();
        SqlSessionFactory build = sqlSessionFactoryBuilder.build(is);
        SqlSession session=build.openSession();
        //代理对象操作数据库
        UserMapper mapper = session.getMapper(UserMapper.class);
        List<User> all = mapper.findAll();
        all.forEach(System.out::println);
        //sqlSession也可以自己操作数据库 实际中很少应用
        /**
         * List<User> list=session.selectList("mapper.UserMapper.findAll");
         * list.forEach(System.out::println);
         */


        //释放资源
        session.close();
        is.close();
    }

    @Test
    public void testAdd() throws IOException {
        InputStream is=Resources.getResourceAsStream("SqlMapConfig.xml");
        SqlSessionFactoryBuilder builder=new SqlSessionFactoryBuilder();
        SqlSessionFactory factory = builder.build(is);
        SqlSession session = factory.openSession();
        UserMapper mapper = session.getMapper(UserMapper.class);
        User user=new User("赵自乾","男","威海");
        mapper.add(user);
        //提交事务
        session.commit();
        session.close();
        is.close();
    }

    @Test
    public void testCache4() throws IOException {
        InputStream is = Resources.getResourceAsStream("SqlMapConfig.xml");
        SqlSessionFactoryBuilder builder = new SqlSessionFactoryBuilder();
        SqlSessionFactory factory = builder.build(is);
        SqlSession session1 = factory.openSession();
        SqlSession session2 = factory.openSession();


        UserMapper mapper1 = session1.getMapper(UserMapper.class);
        UserMapper mapper2 = session2.getMapper(UserMapper.class);


        User user1 = mapper1.findById(1);
        System.out.println(user1);
        System.out.println(user1.hashCode());
        // 让一级缓存失效  除了clearCache不能让一级缓存失效
        session1.commit();
        System.out.println("-------------------------------------------");


        User user2 = mapper2.findById(1);
        System.out.println(user2);
        System.out.println(user2.hashCode());
    }

}
