import domain.PageQuery;
import domain.User;
import mapper.UserMapper;
import org.apache.ibatis.io.Resources;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.SqlSessionFactory;
import org.apache.ibatis.session.SqlSessionFactoryBuilder;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import java.io.IOException;
import java.io.InputStream;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class testUserMapper1 {
    InputStream is=null;
    SqlSession session=null;
    UserMapper mapper=null;
    @Before
    public void before() throws IOException {
        is= Resources.getResourceAsStream("SqlMapConfig.xml");
        SqlSessionFactoryBuilder sqlSessionFactoryBuilder = new SqlSessionFactoryBuilder();
        SqlSessionFactory build = sqlSessionFactoryBuilder.build(is);
        session=build.openSession();
        //代理对象操作数据库
        mapper = session.getMapper(UserMapper.class);
    }

    @Test
    public void testUpdate(){
        User user = new User(8, "zzq", "man", "us");
        mapper.update(user);
        session.commit();
    }

    @Test
    public void delete(){
        int userid=7;
        mapper.delete(userid);
        session.commit();
    }

    @Test
    public void testFindById(){
        int id=8;
        User user = mapper.findById(8);
        System.out.println(user);
    }

    @Test
    public void testFindByNameLike(){
        List<User> users = mapper.findByNameLike("学");
        users.forEach(System.out::println);
    }

    @Test
    public void testFindPage(){
        List<User> list = mapper.findPage1(0, 3);
        list.forEach(System.out::println);
    }

    @Test
    public void  testFindPage2(){
        PageQuery pageQuery = new PageQuery(3,3);

        List<User> page2 = mapper.findPage2(pageQuery);
        page2.forEach(System.out::println);
    }

    @Test
    public void testFindPage3(){
        Map<String,Object> map=new HashMap<>();
        map.put("startIndex",0);
        map.put("pageSize",4);
        List<User> page3 = mapper.findPage3(map);
        page3.forEach(System.out::println);
    }

    @Test
    public void testFindCount(){
        int count = mapper.findCount();
        System.out.println(count);
    }

    @Test
    public void testAdd2(){
        User user = new User("赵自乾", "男", "河南");
        mapper.add2(user);
        session.commit();
        System.out.println(user.getId());
    }



    @After
    public void after() throws IOException {
        session.close();
        is.close();
    }
}
