import domain.User;
import mapper.UserMapper;
import mapper.UserMapper2;
import org.apache.ibatis.io.Resources;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.SqlSessionFactory;
import org.apache.ibatis.session.SqlSessionFactoryBuilder;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class testUserMapper2 {
    InputStream is=null;
    SqlSession session=null;
    UserMapper2 mapper=null;
    @Before
    public void before() throws IOException {
        is= Resources.getResourceAsStream("SqlMapConfig.xml");
        SqlSessionFactoryBuilder sqlSessionFactoryBuilder = new SqlSessionFactoryBuilder();
        SqlSessionFactory build = sqlSessionFactoryBuilder.build(is);
        session=build.openSession();
        //代理对象操作数据库
        mapper = session.getMapper(UserMapper2.class);
    }

    @Test
    public void testFindByCondition(){
        User user = new User();
        List<User> users = mapper.findByCondition(user);
        users.forEach(System.out::println);
    }

    @Test
    public void testUpdateByCondition(){
        User user = new User();
        user.setUsername("朱自清");
        user.setId(8);
        mapper.updateByCondition(user);
        session.commit();
    }

    @Test
    public void testFindByUserName(){
        User user = new User();
        user.setUsername("赵");
        List<User> users = mapper.findByUserName(user.getUsername());
        users.forEach(System.out::println);

    }

    @Test
    public void testDeleteBatch(){
        int[] ids={9,10,11,12};
        mapper.deleteBatch(ids);
        session.commit();
    }

    @Test
    public void testInsertBatch(){
        User user1 = new User("张三", "男", "北京");
        User user2 = new User("雷神", "女", "稻妻");
        List<User> users=new ArrayList<>();
        users.add(user1);
        users.add(user2);
        mapper.insertBatch(users);
        session.commit();
    }

    @Test
    public void testFindUser(){
        Map<String,Object> queryMap=new HashMap<>();
        queryMap.put("sex","男");
        queryMap.put("address","北京");
        List<User> user = mapper.findUser(queryMap);
        user.forEach(System.out::println);
    }


    @After
    public void after() throws IOException {
        session.close();
        is.close();
    }
}
