import mapper.ClassesMapper;
import mapper.StudentMapper;
import mapper.TeacherMapper;
import org.apache.ibatis.io.Resources;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.SqlSessionFactory;
import org.apache.ibatis.session.SqlSessionFactoryBuilder;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;
import pojo.Classes;
import pojo.Student;
import pojo.Teacher;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.List;

public class testManyTableQuery {
    SqlSession session=null;
    InputStream is=null;
    StudentMapper mapper=null;
    @Before
    public void before() throws IOException {
        is= Resources.getResourceAsStream("SqlMapConfig.xml");
        SqlSessionFactoryBuilder builder=new SqlSessionFactoryBuilder();
        SqlSessionFactory factory=builder.build(is);
        session=factory.openSession();
        mapper = session.getMapper(StudentMapper.class);

    }

    @Test
    public void testFindAll(){
        List<Student> students = mapper.findAll();
        students.forEach(System.out::println);
    }

    @Test
    public void testFindAllClasses(){
        ClassesMapper mapper = session.getMapper(ClassesMapper.class);
        List<Classes> all = mapper.findAll();
        all.forEach(System.out::println);
    }

    @Test
    public void testFindAllTeacher(){
        TeacherMapper mapper = session.getMapper(TeacherMapper.class);
        List<Teacher> all = mapper.findAll();
        all.forEach(System.out::println);
    }

    @After
    public void after() throws IOException {
        session.close();
        is.close();
    }
}
